using System;
using Keyoti.SearchEngine.Documents;
using System.IO;

namespace NewReader
{

	/// <summary>
	/// Customized reader class, allows custom code to be written so that document stream can
	/// be obtained.
	/// </summary>
	public class CustomReader:Reader
	{
	

		/// <summary>
		/// Gets the document stream.
		/// </summary>
		public override Stream GetStream(Uri uri)
		{		
			
			if(uri.Scheme.Equals("file"))
			{
					
				//CUSTOM CODE HERE
				//This simple example opens the file as a file stream, however any means of document
				//access can be used
				FileStream stream = new FileStream(uri.LocalPath,FileMode.Open,FileAccess.Read);			
				return stream;	
			} 
			else
			{
				//Also, differentiation can be made between various protocols.
				//.....
				return null;
			}



		}//end GetStream method
	}
}
