using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Keyoti.SearchEngine;
using Keyoti.SearchEngine.Documents;
using Keyoti.SearchEngine.Index;
using Keyoti.SearchEngine.Search;
using Keyoti.SearchEngine.DataAccess;

namespace NewReader
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.ListBox listBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(240, 24);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(64, 24);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "Build Index";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(32, 88);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(128, 23);
			this.button2.TabIndex = 2;
			this.button2.Text = "Perform search";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(176, 80);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(704, 160);
			this.listBox1.TabIndex = 3;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(912, 266);
			this.Controls.Add(this.listBox1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.label1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{			
			//setup Configuration
			Configuration.fileTypesSettings.Clear();
			Configuration.fileTypesSettings.Add("HTML","text/html");
			Configuration.fileTypesSettings.Add("TXT","text/plain");
			Configuration.fileTypesSettings.Add("PDF","application/pdf");
			Configuration.fileTypesSettings.Add("DOC","application/msword");
			Configuration.fileTypesSettings.Add("RTF","application/rtf");
			Configuration.dbType = "xml";
			Configuration.enablePhraseMatching = true;
			Configuration.indexingInterval = 0;
			Configuration.lemmaWeightFactor = 0.5;			
			Configuration.summaryWordLength = 40;
			Configuration.lemmaSearchEnabled = true;
			Configuration.wordsAroundNumber = 5;			
			Configuration.caseSensitivity = Keyoti.SearchEngine.DataAccess.CASE_SENSITIVITY.CASE_INSENSITIVE;			
			Configuration.xmlLocation = Application.StartupPath + "\\..\\..\\IndexDirectory";
			Configuration.exceptionThresholds.Add("dataAccessExceptionThreshold", "10");
			Configuration.exceptionThresholds.Add("readerExceptionsThreshold", "1");			

			AddDocumentsToBeIndexed();

		}

		void AddDocumentsToBeIndexed()
		{
			//build the file identifier string
			string documentFilePath = Application.StartupPath+"\\..\\..\\Documents";

			//add the documents that will be indexed to the document.xml file
			CustomDocumentIndex docIdx = new CustomDocumentIndex();
			docIdx.Open();

			//add documents
			for(int i=0;i<3;i++)
			{
				DocumentRecord docRec = new DocumentRecord(new Uri(documentFilePath+"\\f"+ (i+1) +".txt"));
				docIdx.AddDocument(new Document(docRec));
			}
			docIdx.Close();
		}


		private void button1_Click(object sender, System.EventArgs e)
		{
			CustomDocumentIndex docIdx = new CustomDocumentIndex();
			docIdx.Open();
			docIdx.Build();			
			docIdx.Close();
			label1.Text = "Build done";
		
		}

		private void button2_Click(object sender, System.EventArgs e)
		{							
			SearchAgent sa=new SearchAgent("zodiac", "<<insert trial license key here>>");

			foreach(ResultItem item in sa.Search(1,10))
			{
				listBox1.Items.Add(item.URIString);
			}
		}
	}
}
